
#define BUFF_LEN 256
#define NSECO    1000.
#define SPEEDLIGHT 2.997925

#ifdef MAIN

   void realft();
   void four1();
   int  PrepareGraphics();
   int  ReadSeries();
   int  DoTheJob();
   int  LinesInFile();
   int  GetXYFile();
   void PrintMessage();
   void shut_down();
   void GoGetSpace();
   int check_pow_2();
   int PowSpec();
   int CalcAver();
   int DoAudio();

   char  FileName[BUFF_LEN];

   short *TempBuff;
   int    TempBuffLen;

   FILE *PFile = NULL;

   struct T_series {
      int      Observ;   /* if = 0 no series defined */
      int      RealObs;  /* number of real observations (not the value rounded
                            to a value equal to a power of two) */
      float    SFreq;     /* sampling frequency in unit of 10**12 Hz. 
                             !!!!OBSERVE that the data is sampled in
                                 units of fs (femtoseconds) */ 
      float   *XData;     /* pointer to the X data      */
      float   *YData;     /* pointer to the Y data      */
      float   *Spec;      /* Power spectrum             */
      float   *SpecX1;    /* x-axis                     */
      float   *SpecX2;    /* in units of cm-1           */
      short   *ASpec;     /* pointer to the stuff for the audio */
    } TimeSeries = { 0 , 0 , 0.0 , NULL , NULL , NULL};

   struct Err_Trap {
      int ErrorCode;
    } ErrorTrap = { 0 };

#else

   extern void realft();
   extern void four1();
   extern int  PrepareGraphics();
   extern int  ReadSeries();
   extern int  DoTheJob();
   extern int  LinesInFile();
   extern int  GetXYFile();
   extern void PrintMessage();
   extern void shut_down();
   extern void GoGetSpace();
   extern int check_pow_2();
   extern int PowSpec();
   extern int CalcAver();
   extern int DoAudio();

   extern char FileName[BUFF_LEN];
   extern short *TempBuff;
   extern int    TempBuffLen;

   extern FILE *PFile;
   
   extern struct T_series {
      int      Observ;   /* if = 0 no series defined */
      int      RealObs;  /* number of real observations (not avalue rounded
                            to a value equal to a power of two) */
      float    SFreq;     /* sampling frequency. 
                             !!!!OBSERVE that the data is sampled in
                                 units of fs (femtoseconds) */ 
      float   *XData;     /* pointer to the X data      */
      float   *YData;     /* pointer to the Y data      */
      float   *Spec;      /* Power spectrum             */
      float   *SpecX1;    /* x-axis                     */
      float   *SpecX2;    /* in units of cm-1           */
      short   *ASpec;     /* pointer to the stuff for the audio */
    } TimeSeries;

   extern struct Err_Trap {
      int ErrorCode;
    } ErrorTrap;

#endif










